#include <fstream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>

typedef char Tableau[12] ;

char maxi(Tableau, char);
char mini(Tableau, char);
char max (char a, char b);
char min (char a, char b);
char somme(Tableau, char);

inline char max (char a, char b) { return (a>b)?a:b; };
inline char min (char a, char b) { return (a<b)?a:b; };
#define infini 27000

extern char finale;

class pos
{ public :
  static char next (char i)                             // case suivante d'une case
    { return ++i % 12; };                               //
  static char prenable (char i)                         // on prend 2 ou 3
    { return (i==2 || i==3); };                         //
  static char casesdevant (char i)                      // nombre de cases devant dans son camp
    { return 5-(i%6); };                                //
                                                        //
  public:                                               //
  Tableau n;                                            //
  char gain[2];                                         //
  char quijoue;                                         //  vaut -1, 0 ou 1
  char statut;                                          //
  char gagne() {return (statut & 1) && !(statut & 2); };// bit gain alum bit gain adverse teint
  char perd() {return (statut & 2) && !(statut & 1); }; // bit gain teint bit gain adverse alum                                             // le camp qui joue perd
  char nulle() {return (statut & 3) == 3; };            // bits gains tous allums
  char bloque() { return statut & 4; };                 // bit bloqu alum
                                                        //
  private:                                              //
  char _estjeu(char);                                   // vrifie si une case non vide peut tre joue
                                                        //
  public:                                               //
  pos() {};                                             // constructeur vide
  pos (pos&);                                           // copie constructeur
  char tete() { if (quijoue==-1) return 0;              // tte du camp qui joue
    if (quijoue==1) return 6; return 100; };            //
  char queue() { if (quijoue==-1) return 5;             // queue du cam qui joue
    if (quijoue==1) return 11; return 100; };           //
  char camp() { if (quijoue==-1) return 0;              // camp qui joue : 0/1
	 if (quijoue==1) return 1; return 100; };            //
  char campadverse() { if (quijoue==-1) return 1;       // camp adverse : 0/1
	 if (quijoue==1) return 0; return 100; };            //
  char tete(char camp) { return (camp==0)?0:6 ; };      // tte du de la case i
  char queue(char camp) { return (camp==0)?5:11; };     // queue de la case i
  char camp (char i) { return ((i-6)>=0 || i<0)?1:0; }; // camp d'une case (0 ou 1)
  char campadverse (char i) { return ((i-6)<0)?1:0; };  // camp adverse d'une case (1 ou 0)
  char boncamp(char i) { if (quijoue==0)                // une case est dans le camp qui joue ?
	 return 1; return camp(i)==camp(); };                //
  char gains() { return gain[0]+gain[1]; };             // gains totaux utiliss comme indicateur d'avancement de la partie
  void raz();                                           // 4 pions partout, RZA des gains
  void symetrique() { quijoue=0; };                     // la position est tudie indpendamment du camp qui joue
  void joue (char);                                     // gnrateur de position
  char estjeu (char ajouer);                            // gnratuer de coups : les deux camps peuvent jouer
  char estjeuchezsoi (char ajouer);                     // joue en restant dans son camp
  char marches(char);                                   // combien de coups stictement dans son camp
  char vie(char, char&);                                // combien de coups strictement dans son camp sans monter plus de n pions sur la case
  void arrivees(Tableau);                               // qui arrive ou ?
  void aprendre(Tableau, Tableau);                      // quel coup prendra combien ? (approximation)
  void risque(Tableau, Tableau, Tableau);               // une case sera-t-elle prise  sa sortie ?
  void oppose();                                        // inverse une position (pour les tests)
  int evalue();                                         // value le camp  jouer
  char alphabeta( char, int, int );                     // alpha beta(niveau, alpha, lagage)
                                                        //
  void affiche(char = -10);                             // affiche soit la position, soit le jeu d'une case  partir de la position
  void print(ofstream&);                                // crit -99 puis la position dans un fichier.
  void print();                                         // dans le fichier awchrono.xls
  void read(ifstream&);                                 // lit la position aprs le 1er -99 trouv.
  void getjoueur();                                     // demande le joueur qui joue
  int getjeu();                                         // demande et affiche le jeu du joueur
  char getposition();                                   // retourne 1 si auto, 0 si manuel.
};

void gotojeu();                                         // se place sur la ligne "jeu"
void gotoerreur();                                      // se place sur la ligne "erreur"
int getniveau();                                        // demande et retourne le niveau
int getfenetre();                                       // demande et retourne la fentre alpha
int getelague();                                        // demande et retourne la fenetre d'lagage
char lectureev(); 												  // lecture du tableau des valuations
void printtime (ostream& out);                          // affiche l'heure au format amricain
char* getmessage();                                     // demande le nom et le retourne.
void printheader();                                     // demande le nom, crit le nom et la date sur le fichier awchrono.xls
char nouvellepartie();                                  // demande si une nouvelle partie doit tre joue
void cadre();                                           // affiche le cadre
#define chrono(i) { ofstream f("awchrono.xls", ios::app); f << i; f.close(); }

// SECTION DE FONCTIONS INLINE
inline char pos::estjeuchezsoi(char ajouer)
{ if (n[ajouer]==0 || n[ajouer]>casesdevant(ajouer)) return 0;
  char x = tete(camp(ajouer));
  if (n[x]==0 && n[x+1]==0 && n[x+2]==0 && n[x+3]==0 && n[x+4]==0 && n[x+5]==0) return 0;
  return 1;
};

inline char pos::estjeu(char ajouer)
{ if (n[ajouer]==0 || !boncamp(ajouer)) return 0;
  if (n[ajouer]>casesdevant(ajouer)) return 1;
  return n[ajouer] && _estjeu(ajouer);
};                 

inline char maxi(Tableau t, char camp)
{ char x = (camp==0)?0:6 ; // tte du camp
  return max(max ( t[x+0],max(t[x+1],t[x+2]) ),
             max ( t[x+3],max(t[x+4],t[x+5]) )
            );
};

inline char mini(Tableau t, char camp)
{ char x = (camp==0)?0:6 ; // tte du camp
  return min(min ( t[x+0],min(t[x+1],t[x+2]) ),
             min ( t[x+3],min(t[x+4],t[x+5]) )
            );
};

inline char somme (Tableau t, char camp)
{ char x = (camp==0)?0:6 ; // tte du camp
  return t[x+0]+t[x+1]+t[x+2]+t[x+3]+t[x+4]+t[x+5];
};

// FIN DE SECTION INLINE

