// Les algos de base

#include "aw.h"

void pos::risque(Tableau resultRisque, Tableau resultQuiattaque, Tableau prisesdirectes)
// les calculs sont faits (presque) symtriquement pour le camp qui va jouer et pour l'autre.
// les calculs donnent les pertes de matriel, ainsi que la case qui occasionne ces pertes.
// la lecture inverse du tableau : "l'adversaire crain-t-il une perte" donne les gains de matriel,
// ainsi que la case attaquante qui les provoquera.
// simplement, le camp qui va jouer a besoin de l'avantage strict des marches tandis que l'autre,
// qui jouera en second, peut se contenter de l'galit
// resultRisque : tableau des risques d'une case, son camp jouant en premier.
//          <0 pour une perte, >0 pour un gain
// prisesdirectes : tableau des gains directs esprs lors du jeu d'une case

{ for(char x=0; x<12; x++)
  { resultRisque[x]=0; resultQuiattaque[x]=0; }                       // raz
  char qj = quijoue;
  symetrique();
  for(x=0; x<12; x++)                                                // x = la case  valuer
  { if (!estjeu(x)) continue;                                         // la case est jouable
    pos test = *this;
    test.symetrique();
    test.joue(x);                                                     // test = la position aprs jeu de x
    Tableau arrivee; test.arrivees(arrivee);                          // arrivee = le tableau des arrives aprs jeu de x
    Tableau prises; test.aprendre(prises, arrivee);                   // prises = le tableau des prises en retour du jeu de x (il n'a de signification que dans le camp adverse  x)
    char mesmarchescalculees=0;                                       // les marches en dfense de x ne seront calcules qu'au besoin
    for (char i=tete(campadverse(x)); i<=queue(campadverse(x)); i++)  // i = la case adverse susceptible d'attendre x au passage
    { if (test.n[arrivee[i]]==n[arrivee[i]]) continue;                // si le jeu de x n'a pas augment la case attaque, elle n'est pas concerne
      char risques = prises[i]-prisesdirectes[i];                     // risques = la prise de i strictement due au passage de x
      char mesmarches;                                                // mesmarches = vies en dfense de la case x dans la position d'origine
      if (risques<=0) continue;                                       // si ce risque n'est pas positif, c'est que i n'attend pas x
      char ajout = 48;                                                // ajout = nombre de pions ajouts en x au cours de la dfense.
      if (!mesmarchescalculees) mesmarches = vie(x, ajout);           // mesmarches est calcul une et une seule fois
      ajout = 48-ajout;                                               // ajout = nombre de pions ajouts en x au cours de la dfense.
      // calcul du nombre de cases encore prenables aprs la case d'arrive de x
      char plus=0;                                                    // plus = augmentation du risque par surcharge de x au cours de la dfense
      char depart = arrivee[x]+1;                                     // depart est une case conscutivement vide devant x aprs la dfense
      while (1)
      { if (camp(depart)!=camp(x)) break;                             // fin de boucle car chang de camp
        if (n[depart]+depart>queue(camp(x))) break;                     // fin de boucle car n'est pas vide aprs la dfense
        depart++;
        plus++;
      };
      if (plus>ajout) plus=ajout;                                     // plus = nombre de pions dont la case attaquante peut se charger en restant  l'attaque
      char sesmarches = vie(i, plus);                                 // ses marches = marches de i selon ces conditions
      if ( mesmarches<sesmarches                                      // si mes marches sont infrieures 
           || ( mesmarches==sesmarches && ((qj+1)>>1)==camp(x) )           // ou si mme nombre de marches mais x joue le premier
         )                                                            // alors x sera pris et perdra au moins prisesdirectes
      { if (risques>resultRisque[x])                                  // si le risque de la case n'a pas encore t calcul ou est pire qu'avec une autre case attaquante
        { resultRisque[x] = risques;                                  // pjorer le compte de la case attaque
          resultQuiattaque[x] = i;                                    // noter la case attaquante
        }
      }
    } // case attaquante suivante
  } // case attaque suivante
  quijoue = qj;
  return;
};

void pos::aprendre(Tableau prises, Tableau arrivee)
// calcul des prises directes
// on ne prend pas 5 mais on peut vider le camp.
// elles sont affectes  la case attaquante.
{ char ncase;
  for (int c=0; c<12; c++)   // c=case a jouer
  { int i = arrivee[c];      // i=case arrive de c
    prises[c]=0;
	 ncase=0;
    while (prenable(n[i]+1+(n[c]>11)+(n[c]>22)) && camp(c)!=camp(i))
	 { prises[c]+=n[i]+1+(n[c]>11)+(n[c]>22);
		i--;
      ncase++;
    }
    if (prises[c]==0) continue;                     // si pas de prise, rien  vrifier
	 if (ncase>4) { prises[c]=0; continue; }         // on ne prend pas 5
	 i++;
	 if (i!=0 && i!=6) continue;                    // si n'a pas pris la tte, le camp n'est pas vide
	 if (n[i]+n[i+1]+n[i+2]+n[i+3]+n[i+4]+n[i+5]+ncase != prises[c]) continue;
	 prises[c]=0;
  }
  return;
};

void pos::raz() { for (char a=0; a<12; a++) n[a]=4; gain[0]=gain[1]=0; };

void pos::joue(char ajouer)
{ pos result;       // position rsultante
  char prendre = 1; // prise autorise
  char adversevide; // le camp adverse est laiss vide

  static int nfauxjeu;
  if (!estjeu(ajouer))
  { gotoxy(1,22);
    nfauxjeu++;
    for (int i=0; i<nfauxjeu && i<79; i++) cout << '*';
    return;
  }

  do
  { result = *this;
    char x=ajouer;
    adversevide=0;
    char main = result.n[ajouer];
    result.n[ajouer]=0;
    // donne
    while (main)
    { x=next(x);
      if (x==ajouer) x=next(x);
      main--;
      result.n[x]++;
    }
    // prend
    if (prendre && camp(x)!=camp(ajouer))
    { char nonfin=1;
      char prise=0;
      while (prenable(result.n[x]) && nonfin)
      { result.gain[camp(ajouer)] += result.n[x];
        result.n[x]=0;
        prise++;
        x--;
        if (x==5 || x==11) nonfin=0;
      }
      // vrifie
      if (prise)
      if (prise > 4) { prendre = 0; adversevide = 1; }
      else
      { adversevide = 1;
        x=tete(campadverse(ajouer));
        while (adversevide && x<=queue(campadverse(ajouer)))
        { if (result.n[x]) adversevide=0;
          x++;
        }
      }
      if (adversevide) prendre=0;
    }
  } while (adversevide);
  quijoue = -result.quijoue;
  for (char k=0; k<12; k++) { n[k]=result.n[k]; };
  gain[0]=result.gain[0]; gain[1]=result.gain[1];
  return;
};

char pos::_estjeu(char ajouer)
// contrle si une case NON VIDE peut tre joue
{ if (n[ajouer]>casesdevant(ajouer)) return 1;
  char x=tete(campadverse(ajouer));
  char adversevide=1;
  while (adversevide && x<=queue(campadverse(ajouer)))
  { if (n[x]) adversevide=0;
    x++;
  }
  if (adversevide) return 0; else return 1;
};

char pos::marches(char camp)
// marches d'un camp estimes par le nombre de coups strictement chez soi
{ char result = 0;
  char existe = 1;
  pos test = *this;
  test.symetrique();
  do
  { char x = queue(camp)-1;
    while ((!test.estjeu(x) || n[x]>casesdevant(x)) && x>=tete(camp)) x--;
    if (x>=tete(camp))
    { test.joue(x);
      result++;
    }
    else existe = 0;
  } while (existe);
  return result;
};

char pos::vie(char bloq, char& maxajout)
{ char result = 0;  // nombre de marches
  char existe = 1;  // il existe encore un coup  jouer
  pos test = *this; // tableau pour la simulation
  test.symetrique();
  do                                      // tant qu'il y a un coup  jouer
  { char x;                               // x = case  jouer dans la simulation
    char atteintoupasse;
    x = queue(camp(bloq));                // recherche de x : dpart en queue
    do
    { x--;                                // x = case prcdente de x
      if(x<tete(camp(bloq))) break;       // x a dpass, fin des oprations
      atteintoupasse=0;
      // si x est jouable, sort de la boucle pour jouer x, sinon essaie x prcdent
      // break = joue;
      // continue = ne joue pas et cherche un autre.
      // les commentaires indiquent l'tat de x si la boucle n'est pas interrompue :
      if (!test.estjeu(x)) continue;
      if (!test.estjeuchezsoi(x)) continue;    // x est jouable et chez lui
      if (x>bloq) break;                       // x est sur la case bloque ou derriere
      if (x==bloq) continue;                   // x est derrire la case bloque
      if (test.n[x]+x < bloq) break;           // x atteint ou dpase la case bloque
      if (maxajout==0) continue;               // x peut tre jou
      // il y a peut-tre une stratgie pour chercher des marches de l'autre ct
      atteintoupasse=1;
      if (bloq%6!=2) break;                    // la case bloque est la troisime
      if (x%6==1)
      { if (test.n[x]>1 || !test.estjeuchezsoi(x-1)) break; // 1 sur la deuxime case et jouable sur la premire
        if (test.n[bloq+1]==0 && test.n[bloq+2]==0) continue; else break;
      }                                      // la case  jouer est la tte : c'est soit la dernire soit qu'on a saut sciemment la seconde
      else break;
    } while (1);
    if (x>=tete(camp(bloq)))              // si x est dans le camp
    { test.joue(x);                       // le joue dans la simulation
      maxajout-=atteintoupasse;           // mise a jour du nombre d'ajouts possibles
      result++;                           // et incrmente le nombre de marches
    }
    else existe = 0;                      // sinon, le compte est fini
  } while (existe);                       // fin de boucle "tant qu'il y a un coup  jouer"
  return result;
};

/* -------------------------------------------------------------------------
   si une case attaque marche moins en dfense que la case attaquante en
   attaque, la position est value en la pjorant d'au moins les pertes
   craintes. de cette manire, le programme n'est pas dissuad de sacrifier :
   aprs sacrifice, position matrielle faible mais stratgique assainie.
   ------------------------------------------------------------------------- */

void pos::arrivees(Tableau result)
// qui arrive ou ?
{ for (char x=0; x<12; x++)
  { result[x]  = (n[x]-(n[x]%12))/12;
	 result[x] += x+n[x];
	 result[x] %= 12;
  }
}

pos::pos(pos& p)
{ for (char i=0; i<12; i++) n[i]=p.n[i];
  gain[0]=p.gain[0];
  gain[1]=p.gain[1];
  quijoue = p.quijoue;
  return;
};

void pos::oppose()
{ pos p= (*this);
  for (char i=0; i<12; i++)
  n[i]=p.n[(i+6)%12];
  gain[0]=p.gain[1];
  gain[1]=p.gain[0];
  quijoue = -quijoue;
};

