// la fonction d'valuation

// voir en bas note sur les finales.

#include "aw.h"
#include <fstream.h>

char finale;
unsigned nterm;
int e[2][8];       // le tableau des notes, une pour chaque camp
int lev;           // la ligne utilise dans le tableau

#define avoirgagne 0 //  10000         // avoir gagn
#define avoirMange 1 //   100         // valeur de l'avantage matriel existant
#define bloquer    2 //     95         // les prises certaines  terme
                               // en finale seulement :
#define marcher    3 //    250         // l'avantage des marches
#define undeux     4 //      0         // les combinaisons
#define riendonner 5 //      0         // ne pas pouvoir donner de pions
#define pascadeau  6 //      0         // les pions qui iront chez l'autre
#define unemarche  7 //      0         // une marche 

int pos::evalue()
// quijoue DOIT ETRE NON NUL
{ nterm++;
  int result = 0;
  char i;
  Tableau arriv, aprendr;
  char tc=tete(camp());
  char ta=tete(campadverse());

  // _____________________
  // DETECTION DE FINALE
  // ---------------------
  if ( finale ||
  ( gain[0]+gain[1] > 32 ) )
  { finale = 1; 

  // _____________________
  // DETECTE FIN DE PARTIE
  // ---------------------
    if (                                   // si pas dja fini
       n[0]==0 && n[0]==n[6]               // si la finale est symtrique
    && n[1]==0 && n[1]==n[7]
    && n[2]<2 && n[2]==n[8]
    && n[3]<2 && n[3]==n[9]
    && n[4]<2 && n[4]==n[10]
    && n[5]<2 && n[5]==n[11])
    { gain[0]+=(48-gain[0]-gain[1])/2;
      gain[1]=48-gain[0];
    }
    else if (                               // si pas dja fini
       n[tc]<6 && n[tc+1]<5                // si aucune case du camp qui joue 
    && n[tc+2]<4 && n[tc+3]<3              // n'atteint le camp adverse
    && n[tc+4]<2 && n[tc+5]<1              //
    && n[ta]==0 && n[ta+1]==0              // et camp adverse vide
    && n[ta+2]==0 && n[ta+3]==0            //
    && n[ta+4]==0 && n[ta+5]==0)           // alors :
    { gain[campadverse()]++;               // 1 pion pour l'adversaire
      gain[camp()]=48-gain[campadverse()]; // le reste pour moi
    }
  }                                        //
  vainqueur = 2;                           // pas de vainqueur
  if (gain[1]>=24) vainqueur --;           // vainqueur = 1 => 1 a gagn
  if (gain[0]>=24) vainqueur -=2;          // =0 => 0 a gagn; =-1 => nulle
  if (finale==1)                           // si en finale, la partie peut tre symtrique ou bloque

  // _________________________________________
  // SI LA PARTIE EST NULLE : EVALUATION NULLE
  // -----------------------------------------
  if(vainqueur==-1) return 0; 

  // ______________________________________________________________
  // EVALUATION COMMUNE A TOUS LES CAS Y COMPRIS LES PARTIES FINIES
  // --------------------------------------------------------------
  // avoir mang : avantage matriel acquis
  result += e[lev][avoirMange] *
  (gain[camp()]-gain[campadverse()]);

  // avoir gagn
  if (vainqueur<2)                                   
  { result += e[lev][avoirgagne] *
    ((camp()==vainqueur) ? 1 : -1);  
  }

  // calcul des tableaux arriv et aprendr
  arrivees(arriv);
  aprendre(aprendr, arriv);

  // __________________________
  // SI LA PARTIE EST EN FINALE
  // --------------------------
  if ( finale==1)
  { char mesmarches = marches(camp());
    char sesmarches = marches(campadverse());

    // marcher plus
    result += ((mesmarches>sesmarches)?1:(-1)) * e[lev][marcher];
    result += (mesmarches-sesmarches) * e[lev][unemarche];

    // ne pas donner beaucoup de pions
    for (i=0; i<12; i++)
    { if ( (n[i]-casesdevant(i)) > 1 )
      result += (n[i]-casesdevant(i)) *
      ((camp()==camp(i))?-1:1) * e[lev][pascadeau];
    }

    // traitement spcifique du camp qui marche le plus
    char campquimarche = (mesmarches>sesmarches)?camp():campadverse();
    { char donnerun=0;
      char donnerien=0;
      for (i=tete(campquimarche); i<=queue(campquimarche); i++)
      { if (n[i]==casesdevant(i)+1) donnerun++;
        if (n[i]<casesdevant(i)) donnerien++;
      }
      if (donnerun==1) donnerun=0;                 // pas de undeux avec un seul cadeau
      char sg = (campquimarche==camp())?1:-1;
      result += donnerun * sg * e[lev][undeux];                // si combinaison '1/2'
      if (donnerien==6)
      { result += sg * e[lev][riendonner] *
        (48-gain[0]-gain[1]-1);                    // si ne donne rien  l'autre
    } }
  }

  else // pas en finale

  // ____________________________________
  // TRAITEMENT DES PARTIES NON EN FINALE
  // ------------------------------------
  { Tableau risqu, attaq;

    // bloquer : gain certain  terme
    risque(risqu, attaq, aprendr);
    result += ( maxi (risqu, campadverse())
              - maxi (risqu, camp()) ) * e[lev][bloquer];
  }
  return result;
}

char lectureev()
{ ifstream fev ("awevale.xls");
  int lhaut, lbas;    // les lignes du tableau sur lesquelles il faut lire
  int nb;				 // le nombre de colonnes du tableau 
  fev >> lhaut >> lbas >> nb;
  int lc = 1;
  char x;
  for (lc=1; lc<=lhaut || lc <=lbas; lc++)
  { if (!fev) return 0; else
	 if (lc==lhaut)
    for (x=0; x<nb; x++) if (!fev) return 0; else fev >> e[1][x];
	 else if (lc==lbas)
	 for (x=0; x<nb; x++) if (!fev) return 0; else fev >> e[0][x];
  }
  if (lhaut==lbas) for (x=0; x<nb; x++) e[0][x]=e[1][x];
  fev.close();
  return 1;
};

/*
FINALES A PIONS GROUPES EN QUEUE
4 contre 3 :
3 joue et gagne tout.
4 joue, peut faire un change avec la complicit de 3.
Il lui reste de faon stable 1 pion dans son camp et 2 dans l'autre.
Donc : 4 joue et ramasse 3

2 contre 1 :
2 n'aura plus rien. jeu bloqu.
*/