// la fonction d'valuation : jeu contre lui-mme avec 2 ev diffrentes

#include "aw.h"
class pos1 : public pos
{ public :
  pos1() {raz(); };
  pos1(pos& p);
  int evalue();
  char alphabeta(char, int);
};

class pos2 : public pos
{ public :
  pos2() {raz(); };
  pos2(pos& p);
  int evalue();
  char alphabeta(char, int);
};

extern int evn[6];

extern int alpha; // valeur absolue actuelle de alphabeta : fenetre ou infini
extern int evcentre;   // centre de la fentre;

class ab1
{ public:
  int ev, nbcoups, rangactuel;
  char signe; // doit tre initialis de l'extrieur
  char coups[6];
  pos1 p[6];
  void init(pos1* pc); // 1 -> +infini -> recherche du min
  char coupactuel() { return coups[rangactuel]; };
  pos1* poscoupactuel() { return &(p[coupactuel()]); };
  char peutdescendre() { return (rangactuel < nbcoups); };
};

char pos1::alphabeta(char niveau, int fenetre)
{ ab1* t = new ab1[niveau]; // de 0  niveau-1
  char x;
  char n;
  char fin;
  char meilleurcoup;

  // initialisation signes
  t[niveau-1].signe = -1;
  if (niveau>1) for (x=niveau-2; x>=0; x--) t[x].signe = t[x+1].signe * -1;

  // autres initialisations
  alpha = fenetre;
  // l'valuation se fait  n = niveau+1 1/2 coups.
  // si n est impair (p.e. 1 1/2 coup), c'est 
  // l'adversaire du joueur qui rflchit qui fera l'valuation terminale.
  // Elle sera donc en moyenne = oppos de l'valuation actuelle.
  // Par ailleurs, si n est impair, 0 cherche un min donc son signe est 1 (+infini)
  // => signe = 1 -> changer de signe.
  evcentre = evalue();
  evcentre *= t[0].signe * (-1);

  DEBUT : ;
  n=0;                          // n=0=position d'origine. 
  fin=0;
  meilleurcoup=-20;

  // gnre t[0]                // t[0] = ou sont stoks les positions du premier demi-coup (n=1)
  t[0].init(this);              // t[0] n'est cr qu'une et une seule fois.

  // descend du niveau n demi-coups,
  // en crant t[n] ou sont stoks les rsultats du niveau n+1.
  DESCENTE : ;
  t[n].rangactuel++;            // incrmenter simplement le ndu coup  jouer
  while (n < niveau-1)          // par exemple, n=1
  { pos1* posajouer              // pos1 = la position courante au niveau 1, d'ou il faut descendre
    = t[n].poscoupactuel();     // pos1 est stocke dans t[0] et correspond au coup actuel au rang 0
    t[n+1].init(posajouer);     // initialise t[1] : cre les positions du niveau 2 et les trie pour y descendre dans l'ordre
    t[n+1].rangactuel = 0;      // on va descendre au rang 2 par la premire du tri.
    n++;                        // descendre.
  }                             // n=niveau-1. Les positions issues de ce niveau sont stockes dans t[niveau-1]
  n++;                          // on descend maintenant  niveau
  pos1* pc = t[niveau-1].poscoupactuel();      // pc = coup actuel de la dernire ligne de t
  pos1 test;                                   // test = position ou seront gnrs les coups issus de pc
  int evtest;                                 // evtest = valuation de ces positions terminales
  int evniveau;                               // evniveau = valuation des positions de niveau
  evniveau = evcentre + alpha;                // = + infini car recherche un min
  for (x=pc->queue(); x>=pc->tete(); x--)     // pc joue x, de la queue  la tte
  { if ( !(pc->estjeu(x)) ) continue;         // si x n'est pas un coup, x suivant
    test= *pc;                                // initialise test
    test.joue(x);                             // gnre la position
    evtest = test.evalue();                   // l'value
    if (evtest <= t[niveau-1].ev)             // si le coup test rfute le prcdent
    { n=niveau-1; break; }                    // remonte sans valuer les autres rponses possibles
    if (evtest < evniveau)                    // on cherche un minimum. si la valeur n'est pas un minimum, x suivant.
    { evniveau = evtest; }                    // copie le minimum sur la dernire ligne du tableau
  }                                           // n=niveau ou niveau-1
  if (n==niveau)                              // je ne peux plus descendre. je viens d'valuer toutes les positions terminales
  { if (niveau>=2                             // si je peux couper la branche
    && evniveau >= t[niveau-2].ev)            // et si ev n'est pas plus petite alors que niveau-2 cherche un min
    { n=niveau-2; }                           // remonte directement
    else if(evniveau > t[niveau-1].ev)        // si peut recopier au dessus
    { t[niveau-1].ev = evniveau;              // recopie
      n=niveau-1;                             // et remonte de toutes faons
  } }
  do                                          // dans la boucle, 0<n<niveau-1
  { if (t[n].peutdescendre())                 // et si je peux descendre :
    { goto DESCENTE; }                        // descendre.
    if (n==0)                                 // si je suis en haut et que j'ai tout tudi
    { fin=1; }                                // fin de alphabeta avec la fentre actuelle
    else                                      // je suis en pleine possession de ma note ev.
    { if (n>=2
      && t[n].ev*t[n].signe >= t[n-2].ev*t[n].signe)
      { n=n-2; continue; }
      if (t[n].ev*t[n-1].signe < t[n-1].ev*t[n-1].signe)
      { t[n-1].ev=t[n].ev;
        if (n==1) { meilleurcoup = t[0].coups[t[0].rangactuel]; }
      }
      n--;
  } } while (!fin);                           // jusqu' avoir tudi toutes les positions d'origine
  if (t[0].ev == evcentre+alpha
   || t[0].ev == evcentre-alpha )             // si la note 0 est alpha ou beta
  { if (alpha < (infini / 2) )                // si la fentre peut tre agrandie
    { alpha = alpha * 2; goto DEBUT; }        // agrandir la fentre et recommencer
  }
  delete [niveau]t;                           // librer la mmoire
  return meilleurcoup + tete();               // retourner le nde la case
};



void ab1::init(pos1* pc)
{ char x,y;
  char tete= pc->tete();
  nbcoups = -1;
  rangactuel = -1;
  ev = evcentre + signe*alpha;
  for (x=0; x<6; x++)
  { if (pc->estjeu(x+tete))
    { p[x]= *pc; p[x].joue(x+tete);
      evn[x]=p[x].evalue();
      nbcoups++;
    }
    else evn[x]=infini;
  }
  if (nbcoups == -1) return;
  for (x=0; x<=nbcoups; x++)
  { coups[x]=0;
    for (y=0; y<6; y++) if (evn[y]<evn[coups[x]]) coups[x]=y;
    evn[coups[x]]=infini;
  }
};

class ab2
{ public:
  int ev, nbcoups, rangactuel;
  char signe; // doit tre initialis de l'extrieur
  char coups[6];
  pos2 p[6];
  void init(pos2* pc); // 1 -> +infini -> recherche du min
  char coupactuel() { return coups[rangactuel]; };
  pos2* poscoupactuel() { return &(p[coupactuel()]); };
  char peutdescendre() { return (rangactuel < nbcoups); };
};

char pos2::alphabeta(char niveau, int fenetre)
{ ab2* t = new ab2[niveau]; // de 0  niveau-1
  char x;
  char n;
  char fin;
  char meilleurcoup;

  // initialisation signes
  t[niveau-1].signe = -1;
  if (niveau>1) for (x=niveau-2; x>=0; x--) t[x].signe = t[x+1].signe * -1;

  // autres initialisations
  alpha = fenetre;
  // l'valuation se fait  n = niveau+1 1/2 coups.
  // si n est impair (p.e. 1 1/2 coup), c'est 
  // l'adversaire du joueur qui rflchit qui fera l'valuation terminale.
  // Elle sera donc en moyenne = oppos de l'valuation actuelle.
  // Par ailleurs, si n est impair, 0 cherche un min donc son signe est 1 (+infini)
  // => signe = 1 -> changer de signe.
  evcentre = evalue();
  evcentre *= t[0].signe * (-1);

  DEBUT : ;
  n=0;                          // n=0=position d'origine. 
  fin=0;
  meilleurcoup=-20;

  // gnre t[0]                // t[0] = ou sont stoks les positions du premier demi-coup (n=1)
  t[0].init(this);              // t[0] n'est cr qu'une et une seule fois.

  // descend du niveau n demi-coups,
  // en crant t[n] ou sont stoks les rsultats du niveau n+1.
  DESCENTE : ;
  t[n].rangactuel++;            // incrmenter simplement le ndu coup  jouer
  while (n < niveau-1)          // par exemple, n=1
  { pos2* posajouer              // pos2 = la position courante au niveau 1, d'ou il faut descendre
    = t[n].poscoupactuel();     // pos2 est stocke dans t[0] et correspond au coup actuel au rang 0
    t[n+1].init(posajouer);     // initialise t[1] : cre les positions du niveau 2 et les trie pour y descendre dans l'ordre
    t[n+1].rangactuel = 0;      // on va descendre au rang 2 par la premire du tri.
    n++;                        // descendre.
  }                             // n=niveau-1. Les positions issues de ce niveau sont stockes dans t[niveau-1]
  n++;                          // on descend maintenant  niveau
  pos2* pc = t[niveau-1].poscoupactuel();      // pc = coup actuel de la dernire ligne de t
  pos2 test;                                   // test = position ou seront gnrs les coups issus de pc
  int evtest;                                 // evtest = valuation de ces positions terminales
  int evniveau;                               // evniveau = valuation des positions de niveau
  evniveau = evcentre + alpha;                // = + infini car recherche un min
  for (x=pc->queue(); x>=pc->tete(); x--)     // pc joue x, de la queue  la tte
  { if ( !(pc->estjeu(x)) ) continue;         // si x n'est pas un coup, x suivant
    test= *pc;                                // initialise test
    test.joue(x);                             // gnre la position
    evtest = test.evalue();                   // l'value
    if (evtest <= t[niveau-1].ev)             // si le coup test rfute le prcdent
    { n=niveau-1; break; }                    // remonte sans valuer les autres rponses possibles
    if (evtest < evniveau)                    // on cherche un minimum. si la valeur n'est pas un minimum, x suivant.
    { evniveau = evtest; }                    // copie le minimum sur la dernire ligne du tableau
  }                                           // n=niveau ou niveau-1
  if (n==niveau)                              // je ne peux plus descendre. je viens d'valuer toutes les positions terminales
  { if (niveau>=2                             // si je peux couper la branche
    && evniveau >= t[niveau-2].ev)            // et si ev n'est pas plus petite alors que niveau-2 cherche un min
    { n=niveau-2; }                           // remonte directement
    else if(evniveau > t[niveau-1].ev)        // si peut recopier au dessus
    { t[niveau-1].ev = evniveau;              // recopie
      n=niveau-1;                             // et remonte de toutes faons
  } }
  do                                          // dans la boucle, 0<n<niveau-1
  { if (t[n].peutdescendre())                 // et si je peux descendre :
    { goto DESCENTE; }                        // descendre.
    if (n==0)                                 // si je suis en haut et que j'ai tout tudi
    { fin=1; }                                // fin de alphabeta avec la fentre actuelle
    else                                      // je suis en pleine possession de ma note ev.
    { if (n>=2
      && t[n].ev*t[n].signe >= t[n-2].ev*t[n].signe)
      { n=n-2; continue; }
      if (t[n].ev*t[n-1].signe < t[n-1].ev*t[n-1].signe)
      { t[n-1].ev=t[n].ev;
        if (n==1) { meilleurcoup = t[0].coups[t[0].rangactuel]; }
      }
      n--;
  } } while (!fin);                           // jusqu' avoir tudi toutes les positions d'origine
  if (t[0].ev == evcentre+alpha
   || t[0].ev == evcentre-alpha )             // si la note 0 est alpha ou beta
  { if (alpha < (infini / 2) )                // si la fentre peut tre agrandie
    { alpha = alpha * 2; goto DEBUT; }        // agrandir la fentre et recommencer
  }
  delete [niveau]t;                           // librer la mmoire
  return meilleurcoup + tete();               // retourner le nde la case
};



void ab2::init(pos2* pc)
{ char x,y;
  char tete= pc->tete();
  nbcoups = -1;
  rangactuel = -1;
  ev = evcentre + signe*alpha;
  for (x=0; x<6; x++)
  { if (pc->estjeu(x+tete))
    { p[x]= *pc; p[x].joue(x+tete);
      evn[x]=p[x].evalue();
      nbcoups++;
    }
    else evn[x]=infini;
  }
  if (nbcoups == -1) return;
  for (x=0; x<=nbcoups; x++)
  { coups[x]=0;
    for (y=0; y<6; y++) if (evn[y]<evn[coups[x]]) coups[x]=y;
    evn[coups[x]]=infini;
  }
};
pos1::pos1(pos& p)
{ for (char i=0; i<12; i++) n[i] = p.n[i];
  gain[0]=p.gain[0]; gain[1]=p.gain[1];
  quijoue = p.quijoue;
};

pos2::pos2(pos& p)
{ for (char i=0; i<12; i++) n[i] = p.n[i];
  gain[0]=p.gain[0]; gain[1]=p.gain[1];
  quijoue = p.quijoue;
};

int pos::evalue()
{return 0; };

#define avoirMange       0         // valeur de l'avantage matriel existant
#define manger           1         // valeur de l'avantage materiel au 1er 1/2 coup
#define pasEtreMange     2         // mes cases actuellement attaques
#define bloquer          3         // les prises certaines  terme
#define pasEtreBloque    4         // les pertes certaines  terme
#define marcher          5         // les marches 


int t1[6] = {100,80,-50,90,-100,4};
int t2[6] = {100,80,-50,90,-100,4};


int pos1::evalue()
{ // avoir mang : avantage matriel acquis
  int result = (gain[camp()]-gain[campadverse()]) * t1[avoirMange];

  // manger : avantage matriel immdiat
  Tableau arriv, aprendr, risqu, attaq;
  arrivees(arriv);
  aprendre(aprendr, arriv);
  risque(risqu, attaq, aprendr);
  result += maxi (aprendr, camp()) * t1[manger];

  // ne pas tre mang : cases actuellement attaques (mais surement dfendables)
  result += maxi (aprendr, campadverse()) * t1[pasEtreMange];

  // bloquer l'adversaire : gain certain  terme
  result += maxi (risqu, campadverse()) * t1[bloquer];

  // ne pas tre bloqu : pertes certaines  terme
  result += maxi (risqu, camp()) * t1[pasEtreBloque];

  // marcher
  result += ( (marches(camp())>marches(campadverse())) ? 1 : -1) * gains() * t1[marcher];

  return result;
}

int pos2::evalue()
{ // avoir mang : avantage matriel acquis
  int result = (gain[camp()]-gain[campadverse()]) * t2[avoirMange];

  // manger : avantage matriel immdiat
  Tableau arriv, aprendr, risqu, attaq;
  arrivees(arriv);
  aprendre(aprendr, arriv);
  result += maxi (aprendr, camp()) * t2[manger];

  // ne pas tre mang : cases actuellement attaques (mais surement dfendables)
  result += maxi (aprendr, campadverse()) * t2[pasEtreMange];

  // bloquer l'adversaire : gain certain  terme
  risque(risqu, attaq, aprendr);
  result += (maxi (risqu, campadverse())) * t2[bloquer];

  // ne pas tre bloqu : pertes certaines  terme
  result += maxi (risqu, camp()) * t2[pasEtreBloque];

  // marcher
  result += ( (marches(camp())>marches(campadverse())) ? 1 : -1) * gains() * t2[marcher];

  return result;
}



char partie(char niveau)
// retourne le n du tableau qui a gagn
{ pos1 p1; p1.raz(); p1.quijoue=1;
  pos2 p2; p2.raz();
  char ajouer;
  do
  { ajouer = p1.alphabeta(niveau, infini);
    p2 = p1; p2.joue(ajouer);
    p2.affiche();
    ajouer = p2.alphabeta(niveau, infini);
    p1 = p2; p1.joue(ajouer);
    p1.affiche();
  } while(p1.gain[0]<24 && p1.gain[1]<24);
  if(p1.gain[0]>=24 || p2.gain[0]>=24) return 0;
  else if (p1.gain[1]>=24 || p2.gain[1]>=24) return 1;
  else return -1;
};

void cadre();

main()
{ clrscr();
  char niveau;
  cout << "niveau ? : "; cin >> niveau;
  cadre();
  int res;
  res = partie(niveau);
  gotoxy(1,24);
  cout << res;
};


  
