// le programme ppal pour jeu interactif
// environ 1000 positions terminales

#include "aw.h"

extern unsigned nterm;            // transmis pour info par alphabeta
extern unsigned nelag;            // transmis pour info par alphabeta
extern int alpha;                 // transmis pour info par alphabeta
extern int espoir;                // transmis pour info par alphabeta
pos p;                            // position courante
int niveau,                       // niveau de jeu
    fenetre,                      // alpha
    elague,                       // elagage
    ajouer;                       // coup actuel
  unsigned miniterm = 1000;       // seuil
  unsigned maxiterm = 8000;       // seuil
  int minialpha = 100;            // seuil

void messagefin()
{ if (p.statut & 4)
  { gotojeu();
    cout << "partie nulle.";
  }
  else if (p.statut & 1)
  { gotojeu();
    cout << "Vous avez perdu.";
  }
  else if (p.statut & 2)
  { gotojeu();
    cout << "Vous avez gagn.";
  }
};

char demandefin()
{ messagefin();
  cout << " continuer la partie (o/n) ?";
  char c;
  do cin>>c;
  while (c!='o' && c!='n');
  return (c=='o');
};

void statistiques(char init)      // ajustement des paramtres de alphabeta
{ char compte = 1;                // seuil
  static char fenetreEstEtroite;  // statistiques
  static char fenetreEstLarge;    // statistiques
  static char ntermpetit;         // statistiques
  if (init==0)                    //
  { fenetreEstEtroite=0;          //
    fenetreEstLarge=0;            //
    ntermpetit=0;                 //
    return;                       //
  }                               //
  if (nterm < miniterm)           // si pas beaucoup rflchi
  { ntermpetit++;                 // augmente ntermpettit
  }                               //
  else                            // si beaucoup rflchi
  { ntermpetit=0;                 // raz ntermpetit
	 if (nterm > maxiterm)         // si trop rflchi
	 { niveau--;                   // diminue niveau
	 }                             //
  }                               //
  if (ntermpetit==compte)         // si (compte+1) coups peu rflchis
  { niveau++; }                   // augmente niveau
  if (alpha==infini)              // et pas de fentre,
  { fenetreEstEtroite++;          // nombre de coups d'chec de la fentre augmente
	 fenetreEstLarge=0;            // nombre de coups de succs de la fentre = 0
  }                               //
  else                            // si fentre
  { fenetreEstEtroite=0;          // nombre d'checs = 0
	 fenetreEstLarge++;            // nombre de succs augmente
  }                               //
  if (fenetreEstEtroite==compte)  // si trois faux conscutifs, ouvrir la fentre
  { fenetre =                     //
    (fenetre<(infini/2)) ?        //
    (2*fenetre) : infini;         //
	 fenetreEstEtroite=0;          // raz fenetreEstEtroite
  }                               //
  if (fenetreEstLarge==compte)    // si trois succs de la fentre
  { fenetre /= 1.5;               // ferme la fenetre
    if (fenetre<minialpha)        // mais pas trop
    { fenetre=minialpha; }        //
	 fenetreEstLarge=0;            // raz succes de la fenetre
  }                               //
};                                //
                                  //
void partie()                     // initialise et joue une partie.
{ char continuer=0;               // le joueur a demand de jouer jusqu'au bout
  statistiques(0);                // initialise les statistiques
  char alea =                     // 1 si auto, 0 si manuel
  p.getposition();                // position de dpart
  p.getjoueur();                  // premier joueur
  niveau = 4;                     // niveau fixe de jeu
  fenetre = 350;                  // fentre alpha
  elague = 600;                   // fentre d'lagage
  do                              // traitement d'un coup
  { p.print();                    // position dans le chrono
    p.evalue();                   // met  joue l'octet de statut
    if (p.statut & 4)             // si la partie est bloque
    { messagefin();               // envoi le mesage de fin
      return;                     // et sort de la partie
    }                             // la partie n'est pas bloque
    if (!continuer)               // si la fin est libre
    { if (p.statut & 3)           // si un joueur a gagn ou si nulle
      { continuer = demandefin(); // demande d'arrter
        if (!continuer)           // si veut arrter
        { return; }               // fin
    } }
    if (p.quijoue == -1)          // si joueur joue :
    { ajouer = p.getjeu();        // fait jouer le joueur
      if (ajouer == -100)         // si fin demande
      { return; }                 // sort de la partie
      else chrono(ajouer<<'\n');
    }                             //
    else if (alea==1)             // si le coup doit tre alatoire
    { ajouer = random(5)+7;       // joue au hazard sauf la queue
      alea=0;                     // un seul coup alatoire
    }                             // sinon joue alphabeta
    else                          // si l'ordinateur joue
    { do                          // appelle alpha-beta jusqu' avoir tudi
	   { ajouer = p.alphabeta        // au moins x positions terminales
        (niveau, fenetre, elague);  //
        gotoxy(1,25); cout          // affiche infos techniques :
        <<"term="<<nterm            // nb de positions terminales
        <<" alpha="<<alpha          // valeur de retour de alpha
        <<" elag="<<elague          // fentre d'lagage
        <<" nelag="<<nelag          // nombre d'lagages
        <<" niveau="<<niveau        // niveau de jeu
        <<" espoir="<<espoir        // ev optimum de alphabeta
        <<" jeu="<<int(ajouer)      // le coup actuellement prvu
        <<"  ";                     // efface fin de ligne
        if (nterm<=2) break;        // coup forc
        if (nterm<miniterm) niveau++;
        if (nterm<miniterm/4) niveau++;
      } while                       // alpha-beata retourne son copu  jouer
      (p.estjeu(ajouer)             // si ce n'est pas un coup jouable
      && !(nterm>miniterm           // ou si nterm > seuil
      || espoir >= 9000             // ou si sr de gagner
      || espoir <= -9000)           // ou si sr de perdre
      );
    }
    if (p.estjeu(ajouer))       // si alphabeta a renvoy un coup jouable
	 { statistiques(1);          // rvalue niveau, fentre et elague;
      p.affiche(ajouer);        // affiche le jeu
      p.joue(ajouer);           // le joue effectivement
      chrono
      (ajouer<<'\t'<<
       nterm <<'\t'<<
       alpha <<'\t'<<
       elague<<'\t'<<
       nelag <<'\t'<<
       niveau<<'\t'<<
       espoir<<
       '\n');
    }                             //
  } while (1);                    // FIN DE PARTIE (on ne sort que par des return)
}                                 //
                                  //
main()                            //
{ do                              //
  { cadre();                      // affiche le cadre;
    printheader();                // chrono
    partie();                     // joue une nouvelle partie
    chrono('\t'<<"FIN\n");        // fin dans le chrono
  } while (nouvellepartie());     // tant qu'une partie est demande
};                                //
                                  //
